## snapd 2.21~14.04.1

=== debian/changelog ===
snapd (2.21~14.04.1) trusty; urgency=medium

  * New upstream release, LP: #1656382:
    - trusty backport

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 16 Jan 2017 07:46:23 +0100

snapd (2.21) xenial; urgency=medium

  * New upstream release, LP: #1656382
    - daemon: re-enable reexec
    - interfaces: allow reading installed files from previous revisions
      by default
    - daemon: make activation optional
    - tests: run all snap-confine tests in c-unit-tests task
    - many: fix abbreviated forms of disconnect
    - tests: switch more tests to MATCH
    - store: export userAgent. daemon: print store.UserAgent() on
      startup.
    - tests: test classic confinement `snap list` and  `snap info`
      output
    - debian: skip snap-confine unit tests on nocheck
    - overlord/snapstate: share code between Update and UpdateMany, so
      that it deals with auto-aliases correctly
    - interfaces: upower-observe: refactor to allow snaps to provide a
      slot
    - tests: add end-to-end store test for classic confinement
    - overlord,overlord/snapstate: have UpdateMany retire/enable auto-
      aliases even without new revision
    - interfaces/browser-support: add @{PROC}/@{pid}/fd/[0-9] w and misc
      /run/udev
    - interfaces/builtin: add physical-memory-* and io-ports-control
    - interfaces: allow getsockopt by default since it is so commonly
      used
    - cmd/snap, daemon, overlord/snapstate: tests and fixes for "snap
      refresh" of a classic snap
    - interfaces: allow read/write access of real-time clock with time-
      control interface
    - store: request no CDN via a header using SNAPPY_STORE_NO_CDN
      envvar
    - snap: add information about tracking channel (not just actual
      channel)
    - interfaces: use fewer dot imports
    - overlord/snapstate: remove restrictions on ResetAliases
    - overlord, store: move confinement filtering to the overlord (from
      The Store)
    - many: move interface test helpers to ifacetest package
    - many: implement 'snap aliases'
    - vet: fix for unkeyed fields error on aliases_test.go
    - interfaces: miscellaneous policy updates for network-control,
      unity7, pulseaudio, default and home
    - tests: test for auto-aliases
    - interface hooks: connect plug slot hooks (step 2)
    - cmd/snap: fix internal naming in snap connect
    - snap: use "size" as the json tag in snap.ChannelSnapInfo
    - tests: restore the missing initialization of iface manager causing
      race
    - snap: fix missing sizes in `snap info <remote-snap>`
    - tests: improve cleanup for c-unit-tests
    - cmd/snap-confine: build non-installed libsnap-confine-private.a
    - cmd/snap-confine: small tweaks to seccomp support code
    - interfaces/docker-support: allow /run/shm/aufs.xeno for 14.04
    - many: obtain installed snaps developer/publisher username through
      assertions
    - store: setting of fields for details endpoint
    - cmd/snap-confine: check for rst2man on configure
    - snap: show `snap --help` output when just running `snap`
    - interface/builtin: drop the obsolete checks in udisks2
      SanitizeSlot
    - cmd/snap: remove currency switch following UX review
    - spread: find top-level directory before running generate-
      packaging-dir
    - interface hooks: prepare plug slot hooks (step 1)
    - i18n: use github.com/mvo5/gettext.go (pure go) for i18n to avoid
      cgo
    - many: put a marker in the User-Agent sent by snapd/snap when under
      testingThe User-Agent will look like:
    - tests: fix -reuse and -resend when govendor is missing
    - snap: provide friendlier `snap find` message when no snaps are
      found
    - tests: fix mkversions.sh failure on zesty
    - spread: install build-essentail unconditionally
    - spread: improve qemu ubuntu-14.04-{32,64} support
    - overlord/snapstate,daemon: implement GET /v2/aliases handling
    - store: retry user info request
    - tests: port more snap-confine regression tests
    - tests: cancel the scheduled reboot on ubuntu-core-upgrade-no-gc
      and restore state
    - tests: debug zesty autopkgtest failures
    - overlord/snapstate: use keyed fields on literals
    - tests: use MATCH in install-remove-multi
    - tests: increase wait time for service to be up
    - tests: make debug-each succeed if DENIED doesn't match
    - tests: skip packaging dir generation for non-git based autopkgtest
      runs
    - tests: port refresh-all-undo to MATCH
    - tests: improve snap connect test
    - tests: port additional snap-confine regression tests
    - tests: show --version when it matches unknown
    - tests: optionally use apt proxy for qemu
    - tests: add hello-classic test
    - many: behave more consistently when pointed to staging and
      possibly the fake store
    - overlord/ifacestate: remove stale comments
    - interfaces/apparmor: ignore snippets in classic confinement
    - tests: port first regression test from snap-confine
    - cmd/snap-confine: disable old tests

 -- Michael Vogt <michael.vogt@ubuntu.com>  Fri, 13 Jan 2017 19:39:51 +0100

=== debian/control ===
Source: snapd
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: autoconf,
               automake,
               autotools-dev,
               bash-completion,
               debhelper (>= 9),
               dh-apparmor,
               dh-autoreconf,
               dh-golang (>=1.7),
               dh-systemd,
               fakeroot,
               gettext,
               gnupg2,
               golang-any (>=2:1.6) | golang-1.6,
               indent,
               init-system-helpers,
               libapparmor-dev,
               libglib2.0-dev,
               libseccomp-dev (>= 2.1.1-1ubuntu1~trusty3),
               libudev-dev,
               pkg-config,
               python3,
               python3-docutils,
               python3-markdown,
               squashfs-tools,
               udev
Standards-Version: 3.9.7
Homepage: https://github.com/snapcore/snapd
Vcs-Browser: https://github.com/snapcore/snapd
Vcs-Git: https://github.com/snapcore/snapd.git

Package: golang-github-ubuntu-core-snappy-dev
Architecture: all
Depends: golang-github-snapcore-snapd-dev, ${misc:Depends}
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: golang-github-snapcore-snapd-dev
Architecture: all
Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
        golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
          golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Depends: ${misc:Depends}
Description: snappy development go packages.
 Use these to use the snappy API.

Package: snapd
Architecture: any
Depends: adduser,
         apparmor (>= 2.10.95-0ubuntu2.2),
         ca-certificates,
         cgroup-lite,
         gnupg1 | gnupg,
         linux-generic-lts-xenial,
         snap-confine (= ${binary:Version}),
         squashfs-tools,
# only needed on trusty to pull in the right version.
         sudo (>= 1.8.9p5-1ubuntu1.3),
         systemd (>= 204-5ubuntu20.20),
         ubuntu-core-launcher (= ${binary:Version}),
# only needed on trusty to pull in the right version.
         util-linux (>=2.20.1-5.1ubuntu20.9),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: ubuntu-snappy (<< 1.9), ubuntu-snappy-cli (<< 1.9)
Breaks: ubuntu-snappy (<< 1.9), ubuntu-snappy-cli (<< 1.9)
Conflicts: snap (<< 2013-11-29-1ubuntu1)
Built-Using: ${misc:Built-Using}
Description: Tool to interact with Ubuntu Core Snappy.
 Install, configure, refresh and remove snap packages. Snaps are
 'universal' packages that work across many different Linux systems,
 enabling secure distribution of the latest apps and utilities for
 cloud, servers, desktops and the internet of things.
 .
 This is the CLI for snapd, a background service that takes care of
 snaps on the system. Start with 'snap list' to see installed snaps.

Package: ubuntu-snappy
Architecture: all
Depends: snapd, ${misc:Depends}
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: ubuntu-snappy-cli
Architecture: all
Depends: snapd, ${misc:Depends}
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: ubuntu-core-snapd-units
Architecture: all
Depends: snapd, ${misc:Depends}
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: snap-confine
Architecture: any
Breaks: ubuntu-core-launcher (<< 1.0.32)
Replaces: ubuntu-core-launcher (<< 1.0.32)
Depends: apparmor (>= 2.10.95-0ubuntu2.2), ${misc:Depends}, ${shlibs:Depends}
Description: Support executable to apply confinement for snappy apps
 This package contains an internal tool for applying confinement to snappy app.
 The executable (snap-confine) is ran internally by snapd to apply confinement
 to the started application process. The tool is written in C and carefully
 reviewed to limit the attack surface on the security model of snapd.

Package: ubuntu-core-launcher
Architecture: any
Depends: snap-confine (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.15.7.2)
Description: Launcher for ubuntu-core (snappy) apps
 This package contains the launcher for launching snappy applications

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
export DH_GOLANG_GO_GENERATE=1

export PATH:=${PATH}:${CURDIR}
# make sure that correct go version is found on trusty
export PATH:=/usr/lib/go-1.6/bin:${PATH}

include /etc/os-release

SYSTEMD_UNITS_DESTDIR=
ifeq (${VERSION_ID},"14.04") 
	# We are relying on a deputy systemd setup for trusty,
	# in which systemd does not run as PID 1. To solve the
	# problem of services shipping systemd units and upstart jobs
	# being started twice, we altered systemd on trusty to ignore
	# /lib/systemd/system and instead consider only selected units from
	# /lib/systemd/upstart.
	SYSTEMD_UNITS_DESTDIR="lib/systemd/upstart/"
	# make sure that trusty's golang-1.6 is picked up correctly.
	export PATH:=/usr/lib/go-1.6/bin:${PATH}
else
	SYSTEMD_UNITS_DESTDIR="lib/systemd/system/"
endif

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

BUILDFLAGS:=-buildmode=pie -pkgdir=$(CURDIR)/_build/std
GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
endif

# check if we need to include the testkeys in the binary
TAGS=
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS=-tags withtestkeys
endif

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    VENDOR_ARGS=--enable-nvidia-ubuntu
else
    VENDOR_ARGS=--disable-apparmor
endif

%:
	dh $@ --buildsystem=golang --with=golang --fail-missing --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine

override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine -psnap-confine
	dh_installdeb

override_dh_clean:
ifneq (,$(TEST_GITHUB_AUTOPKGTEST))
	# this will be set by the GITHUB webhook to trigger a autopkgtest
	# we only need to run "govendor sync" here and then its ready
	(export GOPATH="/tmp/go"; \
	  mkdir -p $$GOPATH/src/github.com/snapcore/; \
          cp -ar . $$GOPATH/src/github.com/snapcore/snapd; \
	  go get -u github.com/kardianos/govendor; \
	  (cd $$GOPATH/src/github.com/snapcore/snapd ; $$GOPATH/bin/govendor sync); \
	  cp -ar $$GOPATH/src/github.com/snapcore/snapd/vendor/ .; \
        )
endif
	dh_clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true

override_dh_auto_build:
	# usually done via `go generate` but that is not supported on powerpc
	./mkversion.sh
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	dh_auto_build -- $(BUILDFLAGS) $(TAGS) $(GCCGOFLAGS)
	# Build C bits, sadly manually
	cd cmd && ( autoreconf -i -f )
	cd cmd && ( ./configure --prefix=/usr --libexecdir=/usr/lib/snapd $(VENDOR_ARGS))
	$(MAKE) -C cmd all

override_dh_auto_test:
	dh_auto_test -- $(GCCGOFLAGS)
# a tested default (production) build should have no test keys
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# check that only the main trusted account-key is included
	[ $$(strings _build/bin/snapd|grep -c -E "public-key-sha3-384: [a-zA-Z0-9_-]{64}") -eq 1 ]
	strings _build/bin/snapd|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
endif
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# run the snap-confine tests
	$(MAKE) -C cmd check
endif

override_dh_install:
	# we do not need this in the package, its just needed during build
	rm -rf ${CURDIR}/debian/tmp/usr/bin/xgettext-go
	# uboot-go is not shippable
	rm -f ${CURDIR}/debian/tmp/usr/bin/uboot-go
	# toolbelt is not shippable
	rm -f ${CURDIR}/debian/tmp/usr/bin/toolbelt
	# we do not like /usr/bin/snappy anymore
	rm -f ${CURDIR}/debian/tmp/usr/bin/snappy
	# install dev package files
	mkdir -p debian/golang-github-snapcore-snapd-dev/usr/share
	rm -rf debian/tmp/usr/share/gocode/src/github.com/snapcore/snapd/cmd/snap-confine
	cp -R debian/tmp/usr/share/gocode debian/golang-github-snapcore-snapd-dev/usr/share
	# install udev stuff, must be installed before 80-udisks
	install debian/snapd.autoimport.udev -D debian/snapd/lib/udev/rules.d/66-snapd-autoimport.rules

	# install bash completion files
	install --mode=0644 data/completion/snap -D debian/snapd/usr/share/bash-completion/completions/snap
	# i18n stuff
	mkdir -p debian/snapd/usr/share
	if [ -d share/locale ]; then \
		cp -R share/locale debian/snapd/usr/share; \
	fi
	if [ -f data/info ]; then \
                mkdir -p debian/snapd/usr/lib/snapd; \
		install --mode=0644 data/info debian/snapd/usr/lib/snapd; \
	fi
	# etc/profile.d contains the PATH extension for snap packages
	mkdir -p debian/snapd/etc
	cp -R etc/profile.d debian/snapd/etc
	# etc/X11/Xsession.d will add to XDG_DATA_DIRS so that we have .desktop support
	mkdir -p debian/snapd/etc
	cp -R etc/X11 debian/snapd/etc
	# we install snapd's systemd units
	mkdir -p debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	install --mode=0644 debian/snapd.refresh.timer debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	install --mode=0644 debian/snapd.refresh.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	install --mode=0644 debian/snapd.autoimport.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	install --mode=0644 debian/*.socket debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	install --mode=0644 debian/snapd.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	install --mode=0644 debian/snap.mount.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
	$(MAKE) -C cmd install DESTDIR=$(CURDIR)/debian/tmp
	dh_install

override_dh_auto_install: snap.8
	dh_auto_install -O--buildsystem=golang

snap.8:
	$(CURDIR)/_build/bin/snap help --man > $@

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=golang
	rm -vf snap.8

## snapd 2.21~14.04.2

=== debian/changelog ===
snapd (2.21~14.04.2) trusty; urgency=medium

  * New upstream release, LP: #1656382:
    - trusty backport
    - remove debian/tests/control golang-golang-x-net-dev dependency
      to make autopkgtests work

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 17 Jan 2017 11:42:00 +0100

## snapd 2.21

=== debian/changelog ===
snapd (2.21-2) unstable; urgency=medium

  * Modify snap-confine's apparmor rules to work on Debian when apparmor is
    enabled on the kernel command line.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 25 Jan 2017 10:26:51 +1300

snapd (2.21-1) unstable; urgency=medium

  * New upstream release.
  * Disable i18n so the package can build in stretch without new packages.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 16 Jan 2017 11:15:32 +1300

snapd (2.20-2) unstable; urgency=medium

  * Replace unversioned Conflicts on snap package with versioned
    Breaks/Replaces, now that snap has dropped /usr/bin/snap.
    Closes: #849162.

 -- Steve Langasek <vorlon@debian.org>  Sun, 25 Dec 2016 17:50:25 -0600

snapd (2.20-1) unstable; urgency=medium

  * New upstream release.
  * Update one test (cmd/snap/cmd_interfaces_test.go) to cope with the newer
    golang-go-flags-dev in unstable.
  * Explicitly include 'udev' in Build-Depends.
  * Add tzdata to Build-Depends to avoid ftbfs. (Closes: #848754)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 19 Dec 2016 11:43:55 +1300

snapd (2.16-1) unstable; urgency=medium

  [ Michael Hudson-Doyle ]
  * New upstream release.
  * Import gopkg.in/cheggaaa/pb.v1 rather than github.com/cheggaaa/pb.
  * Switch to unconditional conflict against `snap` (Closes: #826884)
  * Update Vcs-Git and Vcs-Browser to point to alioth. 

  [ Steve Langasek ]
  * Remove govendor from gbp.conf, and import Ubuntu tarball as our
    orig.tar.gz (switching our packaging to non-native).
  * Add Uploaders.
  * Drop lintian overrides not used in Debian because we dynamically link
    against golang-yaml.v2.
  * Bump standards-version, no changes required.
  * Add/fix various lintian overrides.

 -- Steve Langasek <vorlon@debian.org>  Wed, 02 Nov 2016 12:14:52 +0000

snapd (2.0.8+1) unstable; urgency=medium

  * New upstream release.
  * Update lintian-overrides for new paths.
  * debian/copyright: fix a typo (thanks, lintian!)

 -- Steve Langasek <vorlon@debian.org>  Fri, 10 Jun 2016 23:17:22 +0000

snapd (2.0.5+1) unstable; urgency=medium

  * Initial Debian upload.  Closes: #824943.
  * release/release{,_test}.go: use /etc/os-release, which is guaranteed to
    be part of base-files on both Ubuntu and Debian, instead of
    /etc/lsb-release which doesn't exist at all on Debian.
  * drop transitional packages, not needed in Debian.
  * Add lintian overrides for false-positive detection of embedded libyaml.
  * Update Vcs-* fields to point at maintainer's branch.
  * Add a further lintian override for the /snap directory so that the
    package is not automatically rejected by the NEW queue; this directory
    location is certainly subject to discussion for Debian, but let's have
    the discussion rather than blocking the package at the archive level.

 -- Steve Langasek <vorlon@debian.org>  Mon, 23 May 2016 00:36:06 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,10 @@
 Source: snapd
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Steve Langasek <vorlon@debian.org>
+Uploaders: Michael Hudson-Doyle <michael.hudson@ubuntu.com>,
+	Zygmunt Krynicki <me@zygoon.pl>,
+	Luke Faraone <lfaraone@debian.org>
 Build-Depends: autoconf,
                automake,
                autotools-dev,
@@ -14,23 +17,42 @@
                fakeroot,
                gettext,
                gnupg2,
+               golang-check.v1-dev,
+               golang-context-dev,
+               golang-github-coreos-go-systemd-dev,
+               golang-github-gorilla-mux-dev,
+               golang-github-gosexy-gettext-dev,
+               golang-github-mvo5-goconfigparser-dev,
+               golang-github-mvo5-uboot-go-dev,
+               golang-go,
+               golang-go-flags-dev,
+               golang-golang-x-crypto-dev,
+               golang-golang-x-net-dev,
+               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58-1),
+               golang-gopkg-cheggaaa-pb.v1-dev,
+               golang-websocket-dev,
+               golang-yaml.v2-dev,
+               golang-gopkg-macaroon.v1-dev,
+               golang-gopkg-retry.v1-dev,
+               golang-github-gosexy-gettext-dev,
                golang-any (>=2:1.6) | golang-1.6,
                indent,
                init-system-helpers,
                libapparmor-dev,
                libglib2.0-dev,
-               libseccomp-dev (>= 2.1.1-1ubuntu1~trusty3),
+               libseccomp-dev,
                libudev-dev,
                pkg-config,
                python3,
                python3-docutils,
                python3-markdown,
                squashfs-tools,
+               tzdata,
                udev
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://github.com/snapcore/snapd
-Vcs-Browser: https://github.com/snapcore/snapd
-Vcs-Git: https://github.com/snapcore/snapd.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/snapd.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/snapd.git
 
 Package: golang-github-ubuntu-core-snappy-dev
 Architecture: all
@@ -54,24 +76,19 @@
 Depends: adduser,
          apparmor (>= 2.10.95-0ubuntu2.2),
          ca-certificates,
-         cgroup-lite,
          gnupg1 | gnupg,
-         linux-generic-lts-xenial,
          snap-confine (= ${binary:Version}),
          squashfs-tools,
-# only needed on trusty to pull in the right version.
-         sudo (>= 1.8.9p5-1ubuntu1.3),
-         systemd (>= 204-5ubuntu20.20),
+         systemd,
          ubuntu-core-launcher (= ${binary:Version}),
-# only needed on trusty to pull in the right version.
-         util-linux (>=2.20.1-5.1ubuntu20.9),
          ${misc:Depends},
          ${shlibs:Depends}
-Replaces: ubuntu-snappy (<< 1.9), ubuntu-snappy-cli (<< 1.9)
-Breaks: ubuntu-snappy (<< 1.9), ubuntu-snappy-cli (<< 1.9)
-Conflicts: snap (<< 2013-11-29-1ubuntu1)
+Breaks: snap (<< 2013-11-29-5~)
+Replaces: snap (<< 2013-11-29-5~)
 Built-Using: ${misc:Built-Using}
 Description: Tool to interact with Ubuntu Core Snappy.
+ Manage an Ubuntu system with snappy.
+ .
  Install, configure, refresh and remove snap packages. Snaps are
  'universal' packages that work across many different Linux systems,
  enabling secure distribution of the latest apps and utilities for
@@ -79,27 +96,6 @@
  .
  This is the CLI for snapd, a background service that takes care of
  snaps on the system. Start with 'snap list' to see installed snaps.
-
-Package: ubuntu-snappy
-Architecture: all
-Depends: snapd, ${misc:Depends}
-Section: oldlibs
-Description: transitional dummy package
- This is a transitional dummy package. It can safely be removed.
-
-Package: ubuntu-snappy-cli
-Architecture: all
-Depends: snapd, ${misc:Depends}
-Section: oldlibs
-Description: transitional dummy package
- This is a transitional dummy package. It can safely be removed.
-
-Package: ubuntu-core-snapd-units
-Architecture: all
-Depends: snapd, ${misc:Depends}
-Section: oldlibs
-Description: transitional dummy package
- This is a transitional dummy package. It can safely be removed.
 
 Package: snap-confine
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -65,7 +65,7 @@
 endif
 
 %:
-	dh $@ --buildsystem=golang --with=golang --fail-missing --builddirectory=_build
+	dh $@ --buildsystem=golang --with=golang --fail-missing --with systemd --builddirectory=_build
 
 override_dh_fixperms:
 	dh_fixperms -Xusr/lib/snapd/snap-confine
@@ -114,6 +114,50 @@
 	# run the snap-confine tests
 	$(MAKE) -C cmd check
 endif
+
+override_dh_systemd_enable:
+	# enable auto-import
+	dh_systemd_enable \
+		-psnapd \
+		snapd.autoimport.service
+	# we want the auto-update timer enabled by default
+	dh_systemd_enable \
+		-psnapd \
+		snapd.refresh.timer
+	# but the auto-update service disabled
+	dh_systemd_enable \
+		--no-enable \
+		-psnapd \
+		snapd.refresh.service
+	# enable snapd
+	dh_systemd_enable \
+		-psnapd \
+		snapd.socket
+	dh_systemd_enable \
+		-psnapd \
+		snapd.service
+
+override_dh_systemd_start:
+	# we want to start the auto-update timer
+	dh_systemd_start \
+		-psnapd \
+		snapd.refresh.timer
+	# but not start the service
+	dh_systemd_start \
+		--no-start \
+		-psnapd \
+		snapd.refresh.service
+	# start snapd
+	dh_systemd_start \
+		-psnapd \
+		snapd.socket
+	dh_systemd_start \
+		-psnapd \
+		snapd.service
+	# start autoimport
+	dh_systemd_start \
+		-psnapd \
+		snapd.autoimport.service
 
 override_dh_install:
 	# we do not need this in the package, its just needed during build
@@ -138,24 +182,23 @@
 	if [ -d share/locale ]; then \
 		cp -R share/locale debian/snapd/usr/share; \
 	fi
-	if [ -f data/info ]; then \
-                mkdir -p debian/snapd/usr/lib/snapd; \
-		install --mode=0644 data/info debian/snapd/usr/lib/snapd; \
-	fi
 	# etc/profile.d contains the PATH extension for snap packages
 	mkdir -p debian/snapd/etc
 	cp -R etc/profile.d debian/snapd/etc
 	# etc/X11/Xsession.d will add to XDG_DATA_DIRS so that we have .desktop support
 	mkdir -p debian/snapd/etc
 	cp -R etc/X11 debian/snapd/etc
-	# we install snapd's systemd units
+	# we conditionally install snapd's systemd units
 	mkdir -p debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
 	install --mode=0644 debian/snapd.refresh.timer debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
 	install --mode=0644 debian/snapd.refresh.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
 	install --mode=0644 debian/snapd.autoimport.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
 	install --mode=0644 debian/*.socket debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
 	install --mode=0644 debian/snapd.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
-	install --mode=0644 debian/snap.mount.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)
+ifeq ($(RELEASE),trusty)
+	dh_link debian/snapd/$(SYSTEMD_UNITS_DESTDIR)/snapd.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)/multi-user.target.wants/snapd.service
+	dh_link debian/snapd/$(SYSTEMD_UNITS_DESTDIR)/snapd.autoimport.service debian/snapd/$(SYSTEMD_UNITS_DESTDIR)/multi-user.target.wants/snapd.autoimport.service
+endif
 	$(MAKE) -C cmd install DESTDIR=$(CURDIR)/debian/tmp
 	dh_install

## snapd 2.26.1~14.04

=== data/systemd/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
SNAP_MOUNT_DIR := /snap
BINDIR := /usr/bin
LIBEXECDIR := /usr/lib
SYSTEMDSYSTEMUNITDIR := /lib/systemd/system

SYSTEMD_UNITS_GENERATED := $(patsubst %.service.in,%.service,$(wildcard *.service.in))
SYSTEMD_UNITS := ${SYSTEMD_UNITS_GENERATED} snapd.refresh.timer snapd.socket

%.service: %.service.in
	cat $< | \
		sed s:@libexecdir@:${LIBEXECDIR}:g | \
		sed s:@SNAPD_ENVIRONMENT_FILE@:${SNAPD_ENVIRONMENT_FILE}:g | \
		sed s:@bindir@:${BINDIR}:g | \
		sed s:@SNAP_MOUNT_DIR@:${SNAP_MOUNT_DIR}:g  | \
		cat > $@

all: ${SYSTEMD_UNITS}

install: $(SYSTEMD_UNITS)
	install -D -m 0644 -t ${DESTDIR}/${SYSTEMDSYSTEMUNITDIR} $^

clean:
	rm -f ${SYSTEMD_UNITS_GENERATED}

## snapd 2.26.8~14.04

=== data/systemd/Makefile ===
--- 
+++ 
@@ -34,6 +34,7 @@
 
 install: $(SYSTEMD_UNITS)
 	install -D -m 0644 -t ${DESTDIR}/${SYSTEMDSYSTEMUNITDIR} $^
+	install -D -m 0755 -t ${DESTDIR}/${LIBEXECDIR}/snapd snapd.core-fixup.sh
 
 clean:
 	rm -f ${SYSTEMD_UNITS_GENERATED}

## snapd 2.27

=== debian/changelog ===
snapd (2.27-1~test) UNRELEASED; urgency=medium

  * New upstream release.
  * New changes to upstream sources:
    - Disable cmd/snap-seccomp tests as they depend on an unpackaged fork of 
      golang/x/net.
    - Use upstream version of libseccomp-golang.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 10 Aug 2017 21:03:57 +1200

snapd (2.27) xenial; urgency=medium

  * New upstream release, LP: #1703798
    - fix build failure on 32bit fedora
    - interfaces: add password-manager-service implicit classic interface
    - interfaces/greengrass-support: adjust accesses now that have working
      snap
    - interfaces/many, cmd/snap-confine: miscellaneous policy updates
    - interfaces/unity7: allow receiving media key events in (at least)
      gnome-shell
    - cmd: fix re-exec bug when starting from snapd 2.21
    - tests: restore interfaces-account-control properly
    - cmd: fix tests that assume /snap mount
    - cmd: mark arch as non-reexecing distro
    - snap-confine: don't share /etc/nsswitch from host
    - store: talk to api.snapcraft.io for purchases
    - hooks: support for install and remove hooks
    - packaging: fix Fedora support
    - tests: add bluetooth-control interface test
    - store: talk to api.snapcraft.io for assertions
    - tests: remove snapd before building from branch
    - tests: add avahi-observe interface test
    - store: orders API now checks if customer is ready
    - cmd/snap: snap find only searches stable
    - interfaces: updates default, mir, optical-observe, system-observe,
      screen-inhibit-control and unity7
    - tests: speedup prepare statement part 1
    - store: do not send empty refresh requests
    - asserts: fix error handling in snap-developer consistency check
    - systemd: add explicit sync to snapd.core-fixup.sh
    - snapd: generate snap cookies on startup
    - cmd,client,daemon: expose "force devmode" in sysinfo
    - many: introduce and use strutil.ListContains and also
      strutil.SortedListContains
    - assserts,overlord/assertstate: test we don't accept chains of
      assertions founded on a self-signed key coming externally
    - interfaces: enable access to bridge settings
    - interfaces: fix copy-pasted iio vs io in io-ports-control
    - cmd/snap-confine: various small fixes and tweaks to seccomp
      support code
    - interfaces: bring back seccomp argument filtering
    - systemd, osutil: rework systemd logs in preparation for services
      commands
    - tests: store /etc/systemd/system/snap-*core*.mount in snapd-
      state.tar.gz
    - tests: shellcheck improvements for tests/main tasks - first set of
      tests
    - cmd/snap: `--last` for abort and watch, and aliases
      (search→find, change→tasks)
    - tests: shellcheck improvements for tests/lib scripts
    - tests: create ramdisk if it's not present
    - tests: shellcheck improvements for nightly upgrade and regressions
      tests
    - snapd: fix for snapctl get panic on null config values.
    - tests: fix for rng-tools service not restarting
    - systemd: add snapd.core-fixup.service unit
    - cmd: avoid using current symlink in InternalToolPath
    - tests: fix timeout issue for test refresh core with hanging …
    - intefaces: control bridged vlan/ppoe-tagged traffic
    - cmd/snap: include snap type in notes
    - overlord/state: Abort() only visits each task once
    - tests: extend find-private test to cover more cases
    - snap-seccomp: skip socket() tests on systems that use socketcall()
      instead of socket()
    - many: support snap title as localized/title-cased name
    - snap-seccomp: deal with mknod on aarch64 in the seccomp tests
    - interfaces: put base policy fragments inside each interface
    - asserts: introduce NewDecoderWithTypeMaxBodySize
    - tests: fix snapd-notify when it takes more time to restart
    - snap-seccomp: fix snap-seccomp tests in artful
    - tests: fix for create-key task to avoid rng-tools service ramains
      alive
    - snap-seccomp: make sure snap-seccomp writes the bpf file
      atomically
    - tests: do not disable ipv6 on core systems
    - arch: the kernel architecture name is armv7l instead of armv7
    - snap-confine: ensure snap-confine waits some seconds for seccomp
      security profiles
    - tests: shellcheck improvements for tests/nested tasks
    - wrappers: add SyslogIdentifier to the service unit files.
    - tests: shellcheck improvements for unit tasks
    - asserts: implement FindManyTrusted as well
    - asserts: open up and optimize Encoder to help avoiding unnecessary
      copying
    - interfaces: simplify snap-confine by just loading pre-generated
      bpf code
    - tests: restart rng-tools services after few seconds
    - interfaces, tests: add mising dbus abstraction to system-observe
      and extend spread test
    - store: change main store host to api.snapcraft.io
    - overlord/cmdstate: new package for running commands as tasks.
    - spread: help libapt resolve installing libudev-dev
    - tests: show the IP from .travis.yaml
    - tests/main: use pkgdb function in more test cases
    - cmd,daemon: add debug command for displaying the base policy
    - tests: prevent quoting error on opensuse
    - tests: fix nightly suite
    - tests: add linode-sru backend
    - snap-confine: validate SNAP_NAME against security tag
    - tests: fix ipv6 disable for ubuntu-core
    - tests: extend core-revert test to cover bluez issues
    - interfaces/greengrass-support: add support for Amazon Greengrass
      as a snap
    - asserts: support timestamp and optional disabled header on repair
    - tests: reboot after upgrading to snapd on the -proposed pocket
    - many: fix test cases to work with different DistroLibExecDir
    - tests: reenable help test on ubuntu and debian systems
    - packaging/{opensuse,fedora}: allow package build with testkeys
      included
    - tests/lib: generalize RPM build support


=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                dh-systemd,
                fakeroot,
                gettext,
+               grub-common,
                gnupg2,
                golang-check.v1-dev,
                golang-context-dev,
@@ -23,32 +24,36 @@
                golang-github-gorilla-mux-dev,
                golang-github-gosexy-gettext-dev,
                golang-github-mvo5-goconfigparser-dev,
-               golang-github-mvo5-uboot-go-dev,
+               golang-github-seccomp-libseccomp-golang-dev,
                golang-go,
                golang-go-flags-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58-1),
                golang-gopkg-cheggaaa-pb.v1-dev,
-               golang-websocket-dev,
                golang-yaml.v2-dev,
                golang-gopkg-macaroon.v1-dev,
+               golang-gopkg-mgo.v2-dev,
                golang-gopkg-retry.v1-dev,
+               golang-gopkg-tylerb-graceful.v1-dev,
                golang-github-gosexy-gettext-dev,
                golang-any (>=2:1.6) | golang-1.6,
                indent,
                init-system-helpers,
+               libcap-dev,
                libapparmor-dev,
                libglib2.0-dev,
                libseccomp-dev,
                libudev-dev,
+               openssh-client,
                pkg-config,
                python3,
                python3-docutils,
                python3-markdown,
                squashfs-tools,
                tzdata,
-               udev
+               udev,
+               xfslibs-dev
 Standards-Version: 3.9.8
 Homepage: https://github.com/snapcore/snapd
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/snapd.git
@@ -77,15 +82,14 @@
          apparmor (>= 2.10.95-0ubuntu2.2),
          ca-certificates,
          gnupg1 | gnupg,
-         snap-confine (= ${binary:Version}),
+         openssh-client,
          squashfs-tools,
          systemd,
-         ubuntu-core-launcher (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Breaks: snap (<< 2013-11-29-5~)
-Replaces: snap (<< 2013-11-29-5~)
-Built-Using: ${misc:Built-Using}
+Breaks: snap (<< 2013-11-29-5~), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22)
+Replaces: snap (<< 2013-11-29-5~), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22)
+Built-Using: ${Built-Using} ${misc:Built-Using}
 Description: Tool to interact with Ubuntu Core Snappy.
  Manage an Ubuntu system with snappy.
  .
@@ -99,18 +103,15 @@
 
 Package: snap-confine
 Architecture: any
-Breaks: ubuntu-core-launcher (<< 1.0.32)
-Replaces: ubuntu-core-launcher (<< 1.0.32)
-Depends: apparmor (>= 2.10.95-0ubuntu2.2), ${misc:Depends}, ${shlibs:Depends}
-Description: Support executable to apply confinement for snappy apps
- This package contains an internal tool for applying confinement to snappy app.
- The executable (snap-confine) is ran internally by snapd to apply confinement
- to the started application process. The tool is written in C and carefully
- reviewed to limit the attack surface on the security model of snapd.
+Section: oldlibs
+Depends: snapd (= ${binary:Version}), ${misc:Depends}
+Description: Transitional package for snapd
+ This is a transitional dummy package. It can safely be removed.
 
 Package: ubuntu-core-launcher
 Architecture: any
-Depends: snap-confine (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: snapd (= ${binary:Version}), ${misc:Depends}
+Section: oldlibs
 Pre-Depends: dpkg (>= 1.15.7.2)
-Description: Launcher for ubuntu-core (snappy) apps
- This package contains the launcher for launching snappy applications
+Description: Transitional package for snapd
+ This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
export DH_GOLANG_GO_GENERATE=1

export PATH:=${PATH}:${CURDIR}
# make sure that correct go version is found on trusty
export PATH:=/usr/lib/go-1.6/bin:${PATH}

include /etc/os-release

# this is overridden in the ubuntu/14.04 release branch
SYSTEMD_UNITS_DESTDIR="lib/systemd/system/"

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

BUILDFLAGS:=-buildmode=pie -pkgdir=$(CURDIR)/_build/std
GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
endif

# check if we need to include the testkeys in the binary
TAGS=
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS=-tags withtestkeys
endif

BUILT_USING_PACKAGES=
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    # On Ubuntu 16.04 we need to produce a build that can be used on wide
    # variety of systems. As such we prefer static linking over dynamic linking
    # for stability, predicability and easy of deployment. We need to link some
    # things dynamically though: udev has no stable IPC protocol between
    # libudev and udevd so we need to link with it dynamically.
    VENDOR_ARGS=--enable-nvidia-ubuntu --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp
    BUILT_USING_PACKAGES=libcap-dev libapparmor-dev libseccomp-dev
else
ifeq ($(shell dpkg-vendor --query Vendor),Debian)
    VENDOR_ARGS=--disable-apparmor --disable-seccomp
    BUILT_USING_PACKAGES=libcap-dev
else
    VENDOR_ARGS=--disable-apparmor
endif
endif
BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))

%:
	dh $@ --buildsystem=golang --with=golang --fail-missing --with systemd --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine


# The .real profile is a workaround for a bug in dpkg LP: #1673247 that causes
# ubiquity to crash. It allows us to "move" the snap-confine profile from
# snap-confine into snapd in a way that works with old dpkg that is in the live
# CD image.
#
# Because both the usual and the .real profile describe the same binary the
# .real profile takes priority (as it is loaded later).
override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine.real -psnapd
	dh_installdeb

override_dh_clean:
ifneq (,$(TEST_GITHUB_AUTOPKGTEST))
	# this will be set by the GITHUB webhook to trigger a autopkgtest
	# we only need to run "govendor sync" here and then its ready
	(export GOPATH="/tmp/go"; \
	  mkdir -p /tmp/go/src/github.com/snapcore/; \
          cp -ar . /tmp/go/src/github.com/snapcore/snapd; \
	  go get -u github.com/kardianos/govendor; \
	  (cd /tmp/go/src/github.com/snapcore/snapd ; /tmp/go/bin/govendor sync); \
	  cp -ar /tmp/go/src/github.com/snapcore/snapd/vendor/ .; \
        )
endif
	dh_clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true
	$(MAKE) -C data/systemd clean

override_dh_auto_build:
	# usually done via `go generate` but that is not supported on powerpc
	./mkversion.sh
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	dh_auto_build -- $(BUILDFLAGS) $(TAGS) $(GCCGOFLAGS)
	# Build C bits, sadly manually
	cd cmd && ( autoreconf -i -f )
	cd cmd && ( ./configure --prefix=/usr --libexecdir=/usr/lib/snapd $(VENDOR_ARGS))
	$(MAKE) -C cmd all

	# Generate the real systemd units out of the available templates
	$(MAKE) -C data/systemd all

override_dh_auto_test:
	dh_auto_test -- $(GCCGOFLAGS)
# a tested default (production) build should have no test keys
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# check that only the main trusted account-key is included
	[ $$(strings _build/bin/snapd|grep -c -E "public-key-sha3-384: [a-zA-Z0-9_-]{64}") -eq 1 ]
	strings _build/bin/snapd|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
endif
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# run the snap-confine tests
	$(MAKE) -C cmd check
endif

override_dh_systemd_enable:
	# enable auto-import
	dh_systemd_enable \
		-psnapd \
		data/systemd/snapd.autoimport.service
	# we want the auto-update timer enabled by default
	dh_systemd_enable \
		-psnapd \
		data/systemd/snapd.refresh.timer
	# but the auto-update service disabled
	dh_systemd_enable \
		--no-enable \
		-psnapd \
		data/systemd/snapd.refresh.service
	# we want the repair timer enabled by default
	dh_systemd_enable \
		-psnapd \
		data/systemd/snap-repair.timer
	# but the repair service disabled
	dh_systemd_enable \
		--no-enable \
		-psnapd \
		data/systemd/snap-repair.service
	# enable snapd
	dh_systemd_enable \
		-psnapd \
		data/systemd/snapd.socket
	dh_systemd_enable \
		-psnapd \
		data/systemd/snapd.service
	dh_systemd_enable \
		-psnapd \
		data/systemd/snapd.system-shutdown.service
	dh_systemd_enable \
		-psnapd \
		data/systemd/snapd.core-fixup.service

override_dh_systemd_start:
	# we want to start the auto-update timer
	dh_systemd_start \
		-psnapd \
		data/systemd/snapd.refresh.timer
	# but not start the service
	dh_systemd_start \
		--no-start \
		-psnapd \
		data/systemd/snapd.refresh.service
	# start snapd
	dh_systemd_start \
		-psnapd \
		data/systemd/snapd.socket
	dh_systemd_start \
		-psnapd \
		data/systemd/snapd.service
	# start autoimport
	dh_systemd_start \
		-psnapd \
		data/systemd/snapd.autoimport.service
	dh_systemd_start \
		-psnapd \
		data/systemd/snapd.core-fixup.service

override_dh_install:
	# we do not need this in the package, its just needed during build
	rm -rf ${CURDIR}/debian/tmp/usr/bin/xgettext-go
	# toolbelt is not shippable
	rm -f ${CURDIR}/debian/tmp/usr/bin/toolbelt
	# we do not like /usr/bin/snappy anymore
	rm -f ${CURDIR}/debian/tmp/usr/bin/snappy
	# i18n stuff
	mkdir -p debian/snapd/usr/share
	if [ -d share/locale ]; then \
		cp -R share/locale debian/snapd/usr/share; \
	fi

	# install snapd's systemd units, done here instead of
	# debian/snapd.install because the ubuntu/14.04 release
	# branch adds/changes bits here
	$(MAKE) -C data/systemd install DESTDIR=$(CURDIR)/debian/snapd/ SYSTEMDSYSTEMUNITDIR=$(SYSTEMD_UNITS_DESTDIR)

	$(MAKE) -C cmd install DESTDIR=$(CURDIR)/debian/tmp

	# Rename the apparmor profile, see dh_apparmor call above for an explanation.
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
	mv $(CURDIR)/debian/tmp/etc/apparmor.d/usr.lib.snapd.snap-confine $(CURDIR)/debian/tmp/etc/apparmor.d/usr.lib.snapd.snap-confine.real
else
	# HACK: As we want to share the packaging bits between Debian and Ubuntu
	# we have to get an empty file in place which satisfies the item in
	# the snapd.install file.
	install -d $(CURDIR)/debian/tmp/etc/apparmor.d
	touch $(CURDIR)/debian/tmp/etc/apparmor.d/usr.lib.snapd.snap-confine.real
endif
	dh_install

override_dh_auto_install: snap.8
	dh_auto_install -O--buildsystem=golang

snap.8:
	$(CURDIR)/_build/bin/snap help --man > $@

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=golang
	rm -vf snap.8

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(BUILT_USING)"

## snapd 2.27.2~14.04

=== data/systemd/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 SYSTEMDSYSTEMUNITDIR := /lib/systemd/system
 
 SYSTEMD_UNITS_GENERATED := $(patsubst %.service.in,%.service,$(wildcard *.service.in))
-SYSTEMD_UNITS := ${SYSTEMD_UNITS_GENERATED} snapd.refresh.timer snapd.socket
+SYSTEMD_UNITS := ${SYSTEMD_UNITS_GENERATED} $(wildcard *.timer) $(wildcard *.socket)
 
 %.service: %.service.in
 	cat $< | \
